/*
Project     : USART0 TEST1
              uart0_rx.c
Date        : 2006-04-07
Company     : AvrMall.com
Chip type   : ATmega128-16ai
Clock       : 16.000000 MHz
Comment     : ۽  ,  ͷƮ  PC Ͽ USART0 ͸    ͸ ϴ α׷

*/

#include <mega128.h>
#include <stdio.h> 
#include <delay.h>

#define UDRE0 5

char flash TITLE_LINE[] = "M128 Uart Test Program V1.0 COPYRIGHT (C) AvrMall.com\r";

void TxData(char data)
{
        while(!(UCSR0A & (1<<UDRE0)));// UDRE0 CHECK
        UDR0 = data;
}

interrupt [USART0_RXC] void usart0_rx_isr(void)
{
        char status,data;
        
        status=UCSR0A;
        data=UDR0;
        
        TxData(data);
}


void main(void)
{

	// USART0 initialization
	// Communication Parameters: 8 Data, 1 Stop, No Parity
	// USART0 Receiver: On
	// USART0 Transmitter: On
	// USART0 Mode: Asynchronous
	// USART0 Baud rate: 9600
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x67;    //16MHz 
	//UBRR0L=0x33;    //8MHz 
	
	#asm("sei")
	
	putsf(TITLE_LINE);
	
	while(1)
	{}
} 
